local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

a.Rotations = {}
c.RegisterForEvents(a)
s.Spam[AddonName] = function()
    c.Flash(a)
end

a.Rotations.Elemental = {
    Spec = 1,
    OffSwitch = "elemental_off",
    
    FlashInCombat = function()
        a.FlashAll("Elemental Mastery", "Wind Shear")
        a.Flash(
            "Fire Elemental Totem",
            "Searing Totem",
            "Lava Burst",
            "Flame Shock",
            "Earth Shock for Fulmination",
            "Lightning Bolt")
    end,
    
    FlashOutOfCombat = function()
        a.Flash("Thunderstorm")
    end,
    
    FlashAlways = function()
        a.FlashAll("Lightning Shield", "Flametongue Weapon")
    end,
}

a.Rotations.Enhancement = {
    Spec = 2,
    OffSwitch = "enhance_off",
    
    FlashInCombat = function()
        a.FlashAll("Wind Shear")
        a.Flash(
            "Searing Totem",
            "Stormstrike",
            "Lava Lash",
            "Lightning Bolt at 5 Maelstrom",
            "Flame Shock under Unleash Flame",
            "Unleash Elements",
            "Earth Shock",
            "Feral Spirit",
            "Searing Totem Early",
            "Lightning Bolt at 4 Maelstrom")
    end,
    
    FlashAlways = function()
        a.FlashAll(
            "Lightning Shield", "Windfury Weapon", "Flametongue Weapon Offhand")
    end,
}

a.Rotations.Restoration = {
    Spec = 3,
    OffSwitch = "resto_off",
    
    FlashInCombat = function()
        a.FlashAll("Wind Shear")
    end,
        
    FlashAlways = function()
        a.FlashAll("Water Shield", "Earthliving Weapon", "Earth Shield")
    end,
    
    CastSucceeded = function(info)
	    if c.InfoMatches(info, "Earth Shield") then
	        a.EarthShieldTarget = info.Target
	        c.Debug("Event", "Earth Shield target:", a.EarthShieldTarget)
	    end
    end,
}
